﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace N4
{
    class Kraljice
    {
        static int broj = 0;

        /* uslov da se kraljice napadaju = isti red ili ista kolona ili dijagonalno */
        static bool kolizija(int r1, int c1, int r2, int c2)
        {
            return r1 == r2 || c1 == c2 || Math.Abs(r1 - r2) == Math.Abs(c1 - c2);
        }

        static void kraljice(int[] pozicije, int c)
        {
            if (c == pozicije.Length)
            {
                broj++;
                /*ispis u matricnoj formi */
                Console.WriteLine("Resenje broj " + broj);
                for (int i = 0; i < pozicije.Length; i++)
                {
                    for (int j = 0; j < pozicije.Length; j++)
                    {
                        if (pozicije[i] == j)
                            Console.Write(" *");
                        else
                            Console.Write(" 0");
                    }
                    Console.WriteLine();
                }
                
                Console.WriteLine();
                Console.ReadLine();
            }

            // brojac r predstavlja red u koji pokusavamo da ubacim kraljicu
            //koja je u c-toj kolona
            for (int r = 0; r < pozicije.Length; r++)
            {
                bool postojiBar1Kolizija = false;
                //proveravamo da li je neka od prethodnih u koliziji
                for (int j = 0; j < c; j++)
                {
                    /* (r,c) su koordinate pozicije na koju pokusavamo da postavimo kraljicu
                     * (pozicije[j],j) su koordinate prethodno postavljenih kraljica */
                    if (kolizija(r, c, pozicije[j], j))
                    {
                        //dovoljna je 1 kolizija pa da odustanemo od postavljanja kraljice u red r
                        postojiBar1Kolizija = true;
                        break;
                    }
                }
                if (!postojiBar1Kolizija)
                {
                    //ako nije bilo kolizija, znaci da su dosadasnjih c kolona korektno postavljene, pa 
                    //rekurzivno nastavljamo dalje
                    pozicije[c] = r;
                    kraljice(pozicije, c + 1);
                }
            }
        }

        static void Main(string[] args)
        {
            int[] pozicije = new int[8];
            kraljice(pozicije, 0);
         }
    }
}
